#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'configcrypto.ui'
**
** Created: 2012-08-28T13:05:58
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "configcrypto.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <klineedit.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "configcrypto.ui.h"

/*
 *  Constructs a ConfigCrypto as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
ConfigCrypto::ConfigCrypto( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "ConfigCrypto" );
    ConfigCryptoLayout = new QGridLayout( this, 1, 1, 0, KDialog::spacingHint(), "ConfigCryptoLayout"); 

    gb_keys = new QGroupBox( this, "gb_keys" );
    gb_keys->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 1, gb_keys->sizePolicy().hasHeightForWidth() ) );
    gb_keys->setColumnLayout(0, Qt::Vertical );
    gb_keys->layout()->setSpacing( KDialog::spacingHint() );
    gb_keys->layout()->setMargin( KDialog::marginHint() );
    gb_keysLayout = new QGridLayout( gb_keys->layout() );
    gb_keysLayout->setAlignment( Qt::AlignTop );

    lb_key1 = new QLabel( gb_keys, "lb_key1" );

    gb_keysLayout->addWidget( lb_key1, 0, 0 );

    lb_key3 = new QLabel( gb_keys, "lb_key3" );

    gb_keysLayout->addWidget( lb_key3, 2, 0 );

    lb_key2 = new QLabel( gb_keys, "lb_key2" );

    gb_keysLayout->addWidget( lb_key2, 1, 0 );

    lb_key4 = new QLabel( gb_keys, "lb_key4" );

    gb_keysLayout->addWidget( lb_key4, 3, 0 );

    format_1 = new QLabel( gb_keys, "format_1" );
    format_1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)5, 0, 0, format_1->sizePolicy().hasHeightForWidth() ) );
    format_1->setTextFormat( QLabel::RichText );

    gb_keysLayout->addWidget( format_1, 0, 2 );

    format_2 = new QLabel( gb_keys, "format_2" );
    format_2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)5, 0, 0, format_2->sizePolicy().hasHeightForWidth() ) );
    format_2->setTextFormat( QLabel::RichText );

    gb_keysLayout->addWidget( format_2, 1, 2 );

    le_key1 = new KLineEdit( gb_keys, "le_key1" );
    le_key1->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, le_key1->sizePolicy().hasHeightForWidth() ) );

    gb_keysLayout->addWidget( le_key1, 0, 1 );

    le_key2 = new KLineEdit( gb_keys, "le_key2" );
    le_key2->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, le_key2->sizePolicy().hasHeightForWidth() ) );

    gb_keysLayout->addWidget( le_key2, 1, 1 );

    format_3 = new QLabel( gb_keys, "format_3" );
    format_3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)5, 0, 0, format_3->sizePolicy().hasHeightForWidth() ) );
    format_3->setTextFormat( QLabel::RichText );

    gb_keysLayout->addWidget( format_3, 2, 2 );

    le_key3 = new KLineEdit( gb_keys, "le_key3" );
    le_key3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, le_key3->sizePolicy().hasHeightForWidth() ) );

    gb_keysLayout->addWidget( le_key3, 2, 1 );

    format_4 = new QLabel( gb_keys, "format_4" );
    format_4->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)5, 0, 0, format_4->sizePolicy().hasHeightForWidth() ) );
    format_4->setTextFormat( QLabel::RichText );

    gb_keysLayout->addWidget( format_4, 3, 2 );

    le_key4 = new KLineEdit( gb_keys, "le_key4" );
    le_key4->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, le_key4->sizePolicy().hasHeightForWidth() ) );

    gb_keysLayout->addWidget( le_key4, 3, 1 );

    ConfigCryptoLayout->addMultiCellWidget( gb_keys, 2, 2, 0, 2 );

    bg_cryptoMode = new QButtonGroup( this, "bg_cryptoMode" );
    bg_cryptoMode->setColumnLayout(0, Qt::Vertical );
    bg_cryptoMode->layout()->setSpacing( KDialog::spacingHint() );
    bg_cryptoMode->layout()->setMargin( KDialog::marginHint() );
    bg_cryptoModeLayout = new QHBoxLayout( bg_cryptoMode->layout() );
    bg_cryptoModeLayout->setAlignment( Qt::AlignTop );

    rb_openMode = new QRadioButton( bg_cryptoMode, "rb_openMode" );
    bg_cryptoModeLayout->addWidget( rb_openMode );

    rb_restrictMode = new QRadioButton( bg_cryptoMode, "rb_restrictMode" );
    bg_cryptoModeLayout->addWidget( rb_restrictMode );

    ConfigCryptoLayout->addMultiCellWidget( bg_cryptoMode, 1, 1, 0, 2 );
    spacer3 = new QSpacerItem( 80, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    ConfigCryptoLayout->addItem( spacer3, 0, 2 );

    lb_useKey = new QLabel( this, "lb_useKey" );

    ConfigCryptoLayout->addWidget( lb_useKey, 0, 0 );

    cmb_activeKey = new QComboBox( FALSE, this, "cmb_activeKey" );

    ConfigCryptoLayout->addWidget( cmb_activeKey, 0, 1 );
    languageChange();
    resize( QSize(360, 236).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( le_key1, SIGNAL( textChanged(const QString&) ), this, SLOT( slotUpdateKey1Status(const QString&) ) );
    connect( le_key2, SIGNAL( textChanged(const QString&) ), this, SLOT( slotUpdateKey2Status(const QString&) ) );
    connect( le_key3, SIGNAL( textChanged(const QString&) ), this, SLOT( slotUpdateKey3Status(const QString&) ) );
    connect( le_key4, SIGNAL( textChanged(const QString&) ), this, SLOT( slotUpdateKey4Status(const QString&) ) );

    // tab order
    setTabOrder( cmb_activeKey, rb_openMode );
    setTabOrder( rb_openMode, rb_restrictMode );
    setTabOrder( rb_restrictMode, le_key1 );
    setTabOrder( le_key1, le_key2 );
    setTabOrder( le_key2, le_key3 );
    setTabOrder( le_key3, le_key4 );
}

/*
 *  Destroys the object and frees any allocated resources
 */
ConfigCrypto::~ConfigCrypto()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ConfigCrypto::languageChange()
{
    gb_keys->setTitle( tr2i18n( "Crypto Keys" ) );
    lb_key1->setText( tr2i18n( "Key 1:" ) );
    QToolTip::add( lb_key1, tr2i18n( "The first encryption key. 5 or 13 characters are ASCII keys, 10 or 26 characters are hexadecimal keys." ) );
    lb_key3->setText( tr2i18n( "Key 3:" ) );
    QToolTip::add( lb_key3, tr2i18n( "The third encryption key. 5 or 13 characters are ASCII keys, 10 or 26 characters are hexadecimal keys." ) );
    lb_key2->setText( tr2i18n( "Key 2:" ) );
    QToolTip::add( lb_key2, tr2i18n( "The second encryption key. 5 or 13 characters are ASCII keys, 10 or 26 characters are hexadecimal keys." ) );
    lb_key4->setText( tr2i18n( "Key 4:" ) );
    QToolTip::add( lb_key4, tr2i18n( "The fourth encryption key. 5 or 13 characters are ASCII keys, 10 or 26 characters are hexadecimal keys." ) );
    format_1->setText( tr2i18n( "<font color=\"#ff0000\">unrecognized</font>" ) );
    format_2->setText( tr2i18n( "<font color=\"#ff0000\">unrecognised</font>" ) );
    format_3->setText( tr2i18n( "<font color=\"#ff0000\">unrecognised</font>" ) );
    format_4->setText( tr2i18n( "<font color=\"#ff0000\">unrecognised</font>" ) );
    bg_cryptoMode->setTitle( tr2i18n( "Crypto Mode" ) );
    QToolTip::add( bg_cryptoMode, tr2i18n( "Sets which types of packets the card will accept." ) );
    rb_openMode->setText( tr2i18n( "Ope&n" ) );
    QToolTip::add( rb_openMode, tr2i18n( "Makes the card accept encrypted and unencrypted packets." ) );
    rb_restrictMode->setText( tr2i18n( "Restricted" ) );
    QToolTip::add( rb_restrictMode, tr2i18n( "Makes the card only accept encrypted packets." ) );
    lb_useKey->setText( tr2i18n( "Key to use:" ) );
    QToolTip::add( lb_useKey, tr2i18n( "Sets which of the four keys is to be used for transmitting packets." ) );
    cmb_activeKey->clear();
    cmb_activeKey->insertItem( tr2i18n( "Key 1" ) );
    cmb_activeKey->insertItem( tr2i18n( "Key 2" ) );
    cmb_activeKey->insertItem( tr2i18n( "Key 3" ) );
    cmb_activeKey->insertItem( tr2i18n( "Key 4" ) );
}

/****************************************************************************
** ConfigCrypto meta object code from reading C++ file 'configcrypto.h'
**
** Created: Tue Aug 28 13:05:59 2012
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "configcrypto.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *ConfigCrypto::className() const
{
    return "ConfigCrypto";
}

QMetaObject *ConfigCrypto::metaObj = 0;
static QMetaObjectCleanUp cleanUp_ConfigCrypto( "ConfigCrypto", &ConfigCrypto::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString ConfigCrypto::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "ConfigCrypto", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString ConfigCrypto::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "ConfigCrypto", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* ConfigCrypto::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUParameter param_slot_0[] = {
	{ "key", &static_QUType_QString, 0, QUParameter::In }
    };
    static const QUMethod slot_0 = {"slotUpdateKey1Status", 1, param_slot_0 };
    static const QUParameter param_slot_1[] = {
	{ "key", &static_QUType_QString, 0, QUParameter::In }
    };
    static const QUMethod slot_1 = {"slotUpdateKey2Status", 1, param_slot_1 };
    static const QUParameter param_slot_2[] = {
	{ "key", &static_QUType_QString, 0, QUParameter::In }
    };
    static const QUMethod slot_2 = {"slotUpdateKey3Status", 1, param_slot_2 };
    static const QUParameter param_slot_3[] = {
	{ "key", &static_QUType_QString, 0, QUParameter::In }
    };
    static const QUMethod slot_3 = {"slotUpdateKey4Status", 1, param_slot_3 };
    static const QUMethod slot_4 = {"languageChange", 0, 0 };
    static const QMetaData slot_tbl[] = {
	{ "slotUpdateKey1Status(const QString&)", &slot_0, QMetaData::Public },
	{ "slotUpdateKey2Status(const QString&)", &slot_1, QMetaData::Public },
	{ "slotUpdateKey3Status(const QString&)", &slot_2, QMetaData::Public },
	{ "slotUpdateKey4Status(const QString&)", &slot_3, QMetaData::Public },
	{ "languageChange()", &slot_4, QMetaData::Protected }
    };
    metaObj = QMetaObject::new_metaobject(
	"ConfigCrypto", parentObject,
	slot_tbl, 5,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_ConfigCrypto.setMetaObject( metaObj );
    return metaObj;
}

void* ConfigCrypto::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "ConfigCrypto" ) )
	return this;
    return QWidget::qt_cast( clname );
}

bool ConfigCrypto::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: slotUpdateKey1Status((const QString&)static_QUType_QString.get(_o+1)); break;
    case 1: slotUpdateKey2Status((const QString&)static_QUType_QString.get(_o+1)); break;
    case 2: slotUpdateKey3Status((const QString&)static_QUType_QString.get(_o+1)); break;
    case 3: slotUpdateKey4Status((const QString&)static_QUType_QString.get(_o+1)); break;
    case 4: languageChange(); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool ConfigCrypto::qt_emit( int _id, QUObject* _o )
{
    return QWidget::qt_emit(_id,_o);
}
#ifndef QT_NO_PROPERTIES

bool ConfigCrypto::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool ConfigCrypto::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
