#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'configpower.ui'
**
** Created: 2012-08-28T13:06:01
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "configpower.h"

#include <qvariant.h>
#include <qlabel.h>
#include <knuminput.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "configpower.ui.h"

/*
 *  Constructs a ConfigPower as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
ConfigPower::ConfigPower( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "ConfigPower" );
    ConfigPowerLayout = new QGridLayout( this, 1, 1, 0, KDialog::spacingHint(), "ConfigPowerLayout"); 

    lb_sleepTimeout = new QLabel( this, "lb_sleepTimeout" );

    ConfigPowerLayout->addWidget( lb_sleepTimeout, 0, 0 );

    sb_sleepTimeout = new KIntNumInput( this, "sb_sleepTimeout" );
    sb_sleepTimeout->setEnabled( TRUE );
    sb_sleepTimeout->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, sb_sleepTimeout->sizePolicy().hasHeightForWidth() ) );
    sb_sleepTimeout->setMinValue( 0 );
    sb_sleepTimeout->setMaxValue( 60 );

    ConfigPowerLayout->addWidget( sb_sleepTimeout, 0, 1 );

    lb_wakeupPeriod = new QLabel( this, "lb_wakeupPeriod" );

    ConfigPowerLayout->addWidget( lb_wakeupPeriod, 1, 0 );

    bg_packets = new QButtonGroup( this, "bg_packets" );
    bg_packets->setColumnLayout(0, Qt::Vertical );
    bg_packets->layout()->setSpacing( KDialog::spacingHint() );
    bg_packets->layout()->setMargin( KDialog::marginHint() );
    bg_packetsLayout = new QVBoxLayout( bg_packets->layout() );
    bg_packetsLayout->setAlignment( Qt::AlignTop );

    bg_allPackets = new QRadioButton( bg_packets, "bg_allPackets" );
    bg_packetsLayout->addWidget( bg_allPackets );

    rb_unicastOnly = new QRadioButton( bg_packets, "rb_unicastOnly" );
    bg_packetsLayout->addWidget( rb_unicastOnly );

    rb_multicastOnly = new QRadioButton( bg_packets, "rb_multicastOnly" );
    bg_packetsLayout->addWidget( rb_multicastOnly );

    ConfigPowerLayout->addMultiCellWidget( bg_packets, 2, 2, 0, 1 );

    sb_wakeupPeriod = new KIntNumInput( this, "sb_wakeupPeriod" );
    sb_wakeupPeriod->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, sb_wakeupPeriod->sizePolicy().hasHeightForWidth() ) );
    sb_wakeupPeriod->setMinValue( 0 );
    sb_wakeupPeriod->setMaxValue( 60 );

    ConfigPowerLayout->addWidget( sb_wakeupPeriod, 1, 1 );
    languageChange();
    resize( QSize(318, 186).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
ConfigPower::~ConfigPower()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ConfigPower::languageChange()
{
    lb_sleepTimeout->setText( tr2i18n( "Sleep timeout:" ) );
    QToolTip::add( lb_sleepTimeout, tr2i18n( "Sets how long the card will be offline before looking for new packages again." ) );
    sb_sleepTimeout->setSuffix( tr2i18n( " sec" ) );
    lb_wakeupPeriod->setText( tr2i18n( "Wakeup period:" ) );
    QToolTip::add( lb_wakeupPeriod, tr2i18n( "Sets how long the card will be online and looking for new packages before it falls asleep." ) );
    bg_packets->setTitle( tr2i18n( "Receive Packets" ) );
    QToolTip::add( bg_packets, tr2i18n( "Sets which sort of packets to listen to." ) );
    bg_allPackets->setText( tr2i18n( "All" ) );
    QToolTip::add( bg_allPackets, tr2i18n( "Listen to all packet types." ) );
    rb_unicastOnly->setText( tr2i18n( "Unicast only" ) );
    QToolTip::add( rb_unicastOnly, tr2i18n( "Listen to Unicast packets only." ) );
    rb_multicastOnly->setText( tr2i18n( "Multicast/Broadcast only" ) );
    QToolTip::add( rb_multicastOnly, tr2i18n( "Listen to Multicast and Broadcast packets only." ) );
    sb_wakeupPeriod->setSuffix( tr2i18n( " sec" ) );
}

/****************************************************************************
** ConfigPower meta object code from reading C++ file 'configpower.h'
**
** Created: Tue Aug 28 13:06:01 2012
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "configpower.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *ConfigPower::className() const
{
    return "ConfigPower";
}

QMetaObject *ConfigPower::metaObj = 0;
static QMetaObjectCleanUp cleanUp_ConfigPower( "ConfigPower", &ConfigPower::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString ConfigPower::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "ConfigPower", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString ConfigPower::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "ConfigPower", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* ConfigPower::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUParameter param_slot_0[] = {
	{ "ifconfig", &static_QUType_ptr, "IfConfig", QUParameter::In }
    };
    static const QUMethod slot_0 = {"load", 1, param_slot_0 };
    static const QUParameter param_slot_1[] = {
	{ "ifconfig", &static_QUType_ptr, "IfConfig", QUParameter::InOut }
    };
    static const QUMethod slot_1 = {"save", 1, param_slot_1 };
    static const QUMethod slot_2 = {"languageChange", 0, 0 };
    static const QMetaData slot_tbl[] = {
	{ "load(const IfConfig&)", &slot_0, QMetaData::Public },
	{ "save(IfConfig&)", &slot_1, QMetaData::Public },
	{ "languageChange()", &slot_2, QMetaData::Protected }
    };
    metaObj = QMetaObject::new_metaobject(
	"ConfigPower", parentObject,
	slot_tbl, 3,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_ConfigPower.setMetaObject( metaObj );
    return metaObj;
}

void* ConfigPower::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "ConfigPower" ) )
	return this;
    return QWidget::qt_cast( clname );
}

bool ConfigPower::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: load((const IfConfig&)*((const IfConfig*)static_QUType_ptr.get(_o+1))); break;
    case 1: save((IfConfig&)*((IfConfig*)static_QUType_ptr.get(_o+1))); break;
    case 2: languageChange(); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool ConfigPower::qt_emit( int _id, QUObject* _o )
{
    return QWidget::qt_emit(_id,_o);
}
#ifndef QT_NO_PROPERTIES

bool ConfigPower::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool ConfigPower::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
