#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'mainconfigbase.ui'
**
** Created: 2012-08-28T13:06:02
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "mainconfigbase.h"

#include <qvariant.h>
#include <qgroupbox.h>
#include <kpushbutton.h>
#include <qlabel.h>
#include <kcombobox.h>
#include <knuminput.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a MainConfigBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
MainConfigBase::MainConfigBase( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    vbox = new QVBoxLayout( this, 0, 6, "vbox"); 

    grpGeneralSettings = new QGroupBox( this, "grpGeneralSettings" );
    grpGeneralSettings->setColumnLayout(0, Qt::Vertical );
    grpGeneralSettings->layout()->setSpacing( 6 );
    grpGeneralSettings->layout()->setMargin( 11 );
    grpGeneralSettingsLayout = new QGridLayout( grpGeneralSettings->layout() );
    grpGeneralSettingsLayout->setAlignment( Qt::AlignTop );

    pb_activate = new KPushButton( grpGeneralSettings, "pb_activate" );

    grpGeneralSettingsLayout->addMultiCellWidget( pb_activate, 1, 1, 2, 3 );
    spacerrow2 = new QSpacerItem( 146, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    grpGeneralSettingsLayout->addMultiCell( spacerrow2, 2, 2, 2, 4 );

    lb_numConfig = new QLabel( grpGeneralSettings, "lb_numConfig" );

    grpGeneralSettingsLayout->addWidget( lb_numConfig, 2, 0 );

    cmb_presetConfig = new KComboBox( FALSE, grpGeneralSettings, "cmb_presetConfig" );

    grpGeneralSettingsLayout->addWidget( cmb_presetConfig, 1, 1 );

    sb_numConfigs = new KIntNumInput( grpGeneralSettings, "sb_numConfigs" );
    sb_numConfigs->setEnabled( TRUE );
    sb_numConfigs->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, sb_numConfigs->sizePolicy().hasHeightForWidth() ) );
    sb_numConfigs->setMinValue( 1 );
    sb_numConfigs->setMaxValue( 10 );

    grpGeneralSettingsLayout->addWidget( sb_numConfigs, 2, 1 );

    lb_config = new QLabel( grpGeneralSettings, "lb_config" );

    grpGeneralSettingsLayout->addWidget( lb_config, 1, 0 );
    spacer1 = new QSpacerItem( 106, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    grpGeneralSettingsLayout->addMultiCell( spacer1, 0, 0, 3, 4 );
    spacer2 = new QSpacerItem( 66, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    grpGeneralSettingsLayout->addItem( spacer2, 1, 4 );

    cb_usePreset = new QCheckBox( grpGeneralSettings, "cb_usePreset" );

    grpGeneralSettingsLayout->addMultiCellWidget( cb_usePreset, 0, 0, 0, 2 );
    vbox->addWidget( grpGeneralSettings );
    languageChange();
    resize( QSize(581, 135).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
MainConfigBase::~MainConfigBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void MainConfigBase::languageChange()
{
    grpGeneralSettings->setTitle( tr2i18n( "General Settings" ) );
    pb_activate->setText( tr2i18n( "&Activate" ) );
    QToolTip::add( pb_activate, tr2i18n( "Applies the configuration to the interface." ) );
    lb_numConfig->setText( tr2i18n( "Number of configurations:" ) );
    QToolTip::add( lb_numConfig, tr2i18n( "Modifies the number of configurations that this tool should provide." ) );
    QToolTip::add( cmb_presetConfig, tr2i18n( "Selects which of the configurations is to be applied." ) );
    lb_config->setText( tr2i18n( "Configuration to load:" ) );
    QToolTip::add( lb_config, tr2i18n( "Selects which of the configurations is to be applied." ) );
    cb_usePreset->setText( tr2i18n( "Load preset &configuration on startup" ) );
    QToolTip::add( cb_usePreset, tr2i18n( "When this box is checked, your settings are applied when you launch the Control Center module." ) );
}

/****************************************************************************
** MainConfigBase meta object code from reading C++ file 'mainconfigbase.h'
**
** Created: Tue Aug 28 13:06:02 2012
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "mainconfigbase.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *MainConfigBase::className() const
{
    return "MainConfigBase";
}

QMetaObject *MainConfigBase::metaObj = 0;
static QMetaObjectCleanUp cleanUp_MainConfigBase( "MainConfigBase", &MainConfigBase::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString MainConfigBase::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "MainConfigBase", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString MainConfigBase::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "MainConfigBase", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* MainConfigBase::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUMethod slot_0 = {"languageChange", 0, 0 };
    static const QMetaData slot_tbl[] = {
	{ "languageChange()", &slot_0, QMetaData::Protected }
    };
    metaObj = QMetaObject::new_metaobject(
	"MainConfigBase", parentObject,
	slot_tbl, 1,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_MainConfigBase.setMetaObject( metaObj );
    return metaObj;
}

void* MainConfigBase::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "MainConfigBase" ) )
	return this;
    return QWidget::qt_cast( clname );
}

bool MainConfigBase::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: languageChange(); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool MainConfigBase::qt_emit( int _id, QUObject* _o )
{
    return QWidget::qt_emit(_id,_o);
}
#ifndef QT_NO_PROPERTIES

bool MainConfigBase::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool MainConfigBase::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
