#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'propertytablebase.ui'
**
** Created: 2012-08-28T13:06:47
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "propertytablebase.h"

#include <qvariant.h>
#include <qtable.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a PropertyTableBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
PropertyTableBase::PropertyTableBase( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "PropertyTableBase" );
    PropertyTableBaseLayout = new QGridLayout( this, 1, 1, 0, 6, "PropertyTableBaseLayout"); 

    table = new QTable( this, "table" );
    table->setNumCols( table->numCols() + 1 );
    table->horizontalHeader()->setLabel( table->numCols() - 1, tr2i18n( "Property" ) );
    table->setNumCols( table->numCols() + 1 );
    table->horizontalHeader()->setLabel( table->numCols() - 1, tr2i18n( "Value" ) );
    table->setNumRows( 0 );
    table->setNumCols( 2 );
    table->setReadOnly( TRUE );
    table->setSorting( TRUE );

    PropertyTableBaseLayout->addMultiCellWidget( table, 1, 1, 0, 1 );

    cbDeviceSelector = new QComboBox( FALSE, this, "cbDeviceSelector" );

    PropertyTableBaseLayout->addWidget( cbDeviceSelector, 0, 1 );

    tlDevice = new QLabel( this, "tlDevice" );

    PropertyTableBaseLayout->addWidget( tlDevice, 0, 0 );
    languageChange();
    resize( QSize(552, 439).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
PropertyTableBase::~PropertyTableBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void PropertyTableBase::languageChange()
{
    setCaption( tr2i18n( "Wireless Network Device Properties" ) );
    table->horizontalHeader()->setLabel( 0, tr2i18n( "Property" ) );
    table->horizontalHeader()->setLabel( 1, tr2i18n( "Value" ) );
    tlDevice->setText( tr2i18n( "Network device:" ) );
}

/****************************************************************************
** PropertyTableBase meta object code from reading C++ file 'propertytablebase.h'
**
** Created: Tue Aug 28 13:06:47 2012
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "propertytablebase.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *PropertyTableBase::className() const
{
    return "PropertyTableBase";
}

QMetaObject *PropertyTableBase::metaObj = 0;
static QMetaObjectCleanUp cleanUp_PropertyTableBase( "PropertyTableBase", &PropertyTableBase::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString PropertyTableBase::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "PropertyTableBase", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString PropertyTableBase::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "PropertyTableBase", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* PropertyTableBase::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUMethod slot_0 = {"languageChange", 0, 0 };
    static const QMetaData slot_tbl[] = {
	{ "languageChange()", &slot_0, QMetaData::Protected }
    };
    metaObj = QMetaObject::new_metaobject(
	"PropertyTableBase", parentObject,
	slot_tbl, 1,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_PropertyTableBase.setMetaObject( metaObj );
    return metaObj;
}

void* PropertyTableBase::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "PropertyTableBase" ) )
	return this;
    return QWidget::qt_cast( clname );
}

bool PropertyTableBase::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: languageChange(); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool PropertyTableBase::qt_emit( int _id, QUObject* _o )
{
    return QWidget::qt_emit(_id,_o);
}
#ifndef QT_NO_PROPERTIES

bool PropertyTableBase::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool PropertyTableBase::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
